function NewNewInteractionNetwork = BC_UpdateNetwork(Opinions, AgentParameters, InteractionNetwork)

NetworkConstraints = InteractionNetwork{1}; % Network constraints

NewInteractionNetwork = zeros(size(Opinions,1), size(Opinions,1));

for id_agent = 1:size(Opinions,1)
    rad = AgentParameters(id_agent);

    for id_col = 1:size(Opinions,1)

        if NetworkConstraints(id_agent,id_col) == 1

            if id_agent == id_col
    
                NewInteractionNetwork(id_agent,id_col) = 1;
    
            else
    
                distance = abs(Opinions(id_agent) - Opinions(id_col));
        
                if distance<=rad
                    NewInteractionNetwork(id_agent,id_col) = 1;
                else
                    NewInteractionNetwork(id_agent,id_col) = 0;
                end
            end
        end
    end

    NewInteractionNetwork(id_agent,:) = (1/sum(NewInteractionNetwork(id_agent,:)))*NewInteractionNetwork(id_agent,:);

end


NewNewInteractionNetwork = {NetworkConstraints, NewInteractionNetwork};
% The constraints remain the same, but the network changes


end